swagger: '2.0'
info:
  description: "Ce swagger permet d'accéder à l'API de sondage crée lors du tp JPA du module MDI : https://gitlab.istic.univ-rennes1.fr/17019624/Tps_MDI"
  version: 1.0.0
  title: Swagger Sondage API
host: localhost:8080
basePath: /rest
tags:
  - name: Departements
  - name: Employés
  - name: Réunions
schemes:
  - http
paths:
  /departments:
    post:
      tags:
        - Departements
      summary: Enregistrer un département
      description: Enregistre un département avec son nom
      operationId: addDepartment
      consumes:
        - application/json
      produces:
        - application/json
      parameters:
        - in: body
          name: body
          description: Département qui doit être ajouté
          required: true
          schema:
            $ref: '#/definitions/Department'
      responses:
        '200':
          description: Retourne le département enregistré
          schema:
            $ref: '#/definitions/Department'
        '400':
          description: Bad request
        '404':
          description: Not found
  "/departments/{Id}":
    delete:
      tags:
        - Departements
      summary: Supprime un département
      description: ''
      operationId: deleteDepartment
      produces:
        - application/json
      parameters:
        - name: Id
          in: path
          description: Id du département à supprimer
          required: true
          type: string
      responses:
        '204':
          description: OK
        '400':
          description: Bad request
        '404':
          description: Not found
    


  "/users/registration":
    post:
      tags:
        - Employés
      summary: Enregistrer un employé
      description: Enregistre un employé avec son email, son nom et prénom
      operationId: addEmployee
      consumes:
        - application/json
      produces:
        - application/json
      parameters:
        - in: body
          name: body
          description: Employé qui doit être ajouté
          required: true
          schema:
            $ref: '#/definitions/Employee'
      responses:
        '200':
          description: Retourne l'employé enregistré
          schema:
            $ref: '#/definitions/Employee'
        '400':
          description: Bad request
        '404':
          description: Not found
  "/users/connection":
    post:
      tags:
        - Employés
      summary: Connecter un employé
      description: Connecte un employé avec son email
      operationId: connectEmployee
      consumes:
        - application/json
      produces:
        - application/json
      parameters:
        - in: body
          name: body
          description: Employé qui doit être ajouté
          required: true
          schema:
              properties:
                email:
                  type: string
                  example: prenom.nom@esir.com
      responses:
        '200':
          description: Retourne l'employé enregistré
          schema:
            $ref: '#/definitions/Employee'
        '400':
          description: Bad request
        '404':
          description: Not found
  /users:
    get:
      tags:
        - Employés
      summary: Trouver tous les employés
      description: Retourne tous les employés
      operationId: getAllEmployee
      produces:
        - application/json
      responses:
        '200':
          description: Retourne tous les employés
        '400':
          description: Bad request
        '404':
          description: Not found
  "/users/{Id}":
    put:
      tags:
        - Employés
      summary: Met à jour un employé
      description: ''
      operationId: updateEmployee
      consumes:
        - application/json
      produces:
        - application/json
      parameters:
        - name: Id
          in: path
          description: id de l'employé à mettre à jour
          required: true
          type: integer
        - name: body
          in: body
          description: employé à mettre à jour
          required: true
          schema:
            $ref: '#/definitions/Employee'
      responses:
        '200':
          description: OK
          schema:
            $ref: '#/definitions/Employee'
        '405':
          description: Bad request 
    delete:
      tags:
        - Employés
      summary: Supprime un employé
      description: ''
      operationId: deleteEmployee
      produces:
        - application/json
      parameters:
        - name: Id
          in: path
          description: Id de l'employé à supprimer
          required: true
          type: string
      responses:
        '204':
          description: OK
        '400':
          description: Bad request
        '404':
          description: Not found


  /meetings:
    get:
      tags:
        - Réunions
      summary: Trouver toutes les réunions
      description: Retourne tous les réunions
      operationId: getAllMeetings
      produces:
        - application/json
      responses:
        '200':
          description: Retourne tous les réunions
        '400':
          description: Bad request
        '404':
          description: Not found
  "/meetings/{Id}":
    delete:
      tags:
        - Réunions
      summary: Supprime une réunion
      description: ''
      operationId: deleteMeeting
      produces:
        - application/json
      parameters:
        - name: Id
          in: path
          description: Id de la réunion à supprimer
          required: true
          type: string
      responses:
        '204':
          description: OK
        '400':
          description: Bad request
        '404':
          description: Not found


definitions:
  Department:
    type: object
    required:
      - name
    properties:
      name:
        type: string
        example: SI
  Employee:
    type: object
    required:
      - name
      - firstname
      - email
    properties:
      name:
        type: string
        example: Nom
      firstname:
        type: string
        example: Prénom
      email:
        type: string
        example: prenom.nom@esir.com
  